/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "openldev.h"
#include <string>

static bool on_delete_event (GtkWidget*, GdkEvent*, gpointer);
static void on_destroy (GtkObject*, gpointer);

// The magic all begins here...
int main (int argc, 
          char *argv[])
{
  gtk_init (&argc, &argv);
  
  GtkWidget *window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  OpenLDev *win;
  
  win = new OpenLDev(window);
  string icon = string(INSTALL_PREFIX) + "/share/pixmaps/openldev/openldev24.png";
  gtk_window_set_icon_from_file (GTK_WINDOW(window), icon.c_str(), NULL);

  g_signal_connect (G_OBJECT(window), "delete-event",
                    G_CALLBACK(on_delete_event), NULL);
  g_signal_connect (G_OBJECT(window), "destroy",
                    G_CALLBACK(on_destroy), NULL);
  g_signal_connect (G_OBJECT(window), "hide",
                    G_CALLBACK(on_destroy), NULL);
  
  gtk_widget_show (window);
  gtk_main();
	
  return 0;
}

static bool on_delete_event (GtkWidget *widget, 
                             GdkEvent *event, 
                             gpointer data)
{
  return false;
}

static void on_destroy (GtkObject *object,
                        gpointer data)
{
  gtk_main_quit();
}
