/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef NEW_H
#define NEW_H

#include "template.h"

#include <cstdio>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <sys/stat.h>

// New file/project class
class NewProjectDialog
{
public:
  NewProjectDialog (TemplateList*);
 
  GtkWidget* get_dialog();
  void initialize_objects();
  void populate_combobox();

  bool key_pressed_name(GdkEventKey*);
  string get_filename();

  string check_for_errors();
  string create_odp_file_text(string&);
  void create_location();
  void create_project_from_template(string);
  void clean_white_space_and_replace_content (string&, bool);

private:
  GtkWidget *dialog, *cancel, *apply, *browse, *name, *author, *email,
            *homepage, *version, *location, *combobox;
  string file_location;
  TemplateList *tlist;

private:
  friend void on_apply_pressed (GtkWidget*, gpointer);
  friend void on_browse_pressed (GtkWidget*, gpointer);
  friend void on_cancel_pressed (GtkWidget*, gpointer);
};

#endif
