/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "outputterminal.h"

OutputTerminal::OutputTerminal()
{
  int value;
  
  terminal = vte_terminal_new();
  value = vte_terminal_fork_command (VTE_TERMINAL(terminal), 
          "/bin/bash", NULL, NULL, NULL, FALSE, FALSE, FALSE);
  vte_terminal_set_font_from_string(VTE_TERMINAL(terminal), "Monospace 10");
  GTK_WIDGET_SET_FLAGS(VTE_TERMINAL(terminal), GTK_CAN_FOCUS);
  vte_terminal_set_scroll_on_output(VTE_TERMINAL(terminal), true);
  vte_terminal_set_scroll_on_keystroke(VTE_TERMINAL(terminal), true);
  vte_terminal_set_mouse_autohide(VTE_TERMINAL(terminal), true);
  
  scrollbar = gtk_vscrollbar_new(vte_terminal_get_adjustment(VTE_TERMINAL(terminal)));
  hbox = gtk_hbox_new(false, 0);
  gtk_box_pack_start(GTK_BOX(hbox), terminal, true, true, 0);
  gtk_box_pack_start(GTK_BOX(hbox), scrollbar, false, false, 0);  
  
  gtk_widget_show(terminal);
  gtk_widget_show(scrollbar);
  gtk_widget_show(hbox);
}

void OutputTerminal::run_command (string command)
{ vte_terminal_feed_child(VTE_TERMINAL(terminal), command.c_str(), command.length());
}

void OutputTerminal::grab_focus()
{ gtk_widget_grab_focus(terminal);
}

GtkWidget* OutputTerminal::get_terminal()
{ return terminal;
}

GtkWidget* OutputTerminal::get_hbox()
{ return hbox;
}
